#include <stdio.h>
#include <stdarg.h>
#include <assert.h>
#include "lists.h"
#include "value.h"
#include "mapping.h"

value *
mapping_new (void)
{
	value *v = value_new(MM_MAPPING);
	v->v_plength = 4;	/* strlen("([])") */
	v->v_array = list_new();
	return v;
}

value *
mapping_append (value *m, value *v)
{
	listentry	*node;
	assert(m);
	assert(m->v_type == MM_MAPPING);
	assert(v);

	node = list_item_new();
	node->data = (void *)(v);
	list_append(m->v_array, node);
	m->v_plength += v->v_plength + V_LEN_COMMA;
	return m;
}

value *
mapping_data_new (value *k, value *d)
{
	value *v;
	v = value_new(MM_MAPDATA);
	v->k = k;
	v->d = d;
	v->v_plength += (k?k->v_plength:V_LEN_NUL);
	v->v_plength += (d?d->v_plength:V_LEN_NUL);
	v->v_plength += V_LEN_COLON;
	return v;
}

value *
mapping_create (value *m, char *fmt, ... )
{
	va_list	 ap;
	value	*v;
	va_start(ap, fmt);
	if (!m) m = mapping_new();
	while (*fmt) {
		switch(*fmt++) {
			case 'd':
				v = va_arg(ap, value *);
				if (v->v_type == MM_MAPDATA)
					mapping_append(m, v);
				else
					fprintf(stderr,
						"Non MAPDATA item in mapping append\n");
				break;
			default:
				fprintf(stderr, "Non MAPDATA item in format string\n");
				break;
		}
	}
	va_end(ap);
	return m;
}
