#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "packet.h"
#include "config.h"
#include "value.h"
#include "lists.h"
#include "i3.h"
#include "array.h"
#include "mapping.h"

long	 i3_ntypes;

void packet_init (void)
	{ i3_ntypes = sizeof(i3_typedata) / sizeof(i3_typedata[0]); }

char * packet_int_to_desc (int p_type)
	{ return ((p_type<i3_ntypes)?i3_typedata[p_type].i3_desc:NULL); }
int
packet_desc_to_int (char *p_desc)
{
	int		  i = 0;
	while (i3_typedata[i].i3_desc &&
			strcmp(i3_typedata[i].i3_desc, p_desc)) i++;
	return (i3_typedata[i].i3_desc?i:-1);
}

char *
packet_fmt (char *p_desc)
{
	int	 i;
	i = packet_desc_to_int(p_desc);
	// if (i >= i3_ntypes) return NULL;
	return i3_typedata[i].i3_fmt;
}

value *
packet_head_create (char *p_desc, ST_NAMES)
{
	if (packet_desc_to_int(p_desc) == -1) {
		fprintf(stderr, "Bad packet type '%s'\n", p_desc);
		return NULL;
	}

	return array_create(NULL, "svssss", p_desc, 5, CONFIG_MUDNAME,
		s_uname, (t_mname?t_mname:CONFIG_ROUTER_NAME), t_uname);
}
