#ifndef __VALUE_H__
#define __VALUE_H__

/* This could be interesting. */
#define MM_NONE		(1<<0)
#define MM_ARRAY	(1<<1)
#define MM_EARRAY	(1<<2)
#define MM_STRING	(1<<3)
#define MM_VALUE	(1<<4)
#define MM_MAPPING	(1<<5)
#define MM_EMAPPING	(1<<6)
#define MM_MAPDATA	(1<<7)
#define MM_COMMA	(1<<11)
#define MM_COLON	(1<<12)
#define MM_EOL		(1<<13)
#define MM_EOF		(1<<14)
#define MM_ERR		(1<<15)

#define VNUL "0"
#define V_LEN_NUL (sizeof(char))
#define V_LEN_COMMA (sizeof(char))
#define V_LEN_COLON (sizeof(char))
#define V_LEN_QUOTES (2 * sizeof(char))

typedef
struct _value {
	int			 v_type;		/* Type (as above) */
	long		 v_plength;		/* Length when printed */
	/* Union these */
	long		 v_value;		/* Integer value */
	char		*v_string;		/* String data */
	void		*v_array;		/* Array pointer for arrays and maps */
	struct _value	*k;			/* Key for mappings */
	struct _value	*d;			/* Data for mappings */
} value;

int			 value_size		(long v_value);
value		*value_new		(int v_type);
value		*value_new_data	(int v_type, void *v_data);
void		 value_destroy	(value *v);

#endif
